﻿using System;

namespace FuncActionDemo
{
    public class KickinIt
    {

        //public delegate void MethodTakesStringWithNoReturnHandler(string value);
        //public delegate Int32 MethodTakesIntsAndReturnsHandler(Int32 a, Int32 b);

        public void CalculateData( Int32 a, Int32 b)
        {

            
            if ( a == 1)
            {
                var someClassThatDoesStuff = new SomeClassThatDoesStuff();
                var result = someClassThatDoesStuff.TakeTwoNumberAndReturnTheResult(a, b);
                someClassThatDoesStuff.TakeInAStringAndWritesItOut(string.Format("The result was {0}...", result));
            }
            else
            {
                var someClassThatDoesStuff = new AnotherClassThatDoesStuff();
                var result = someClassThatDoesStuff.TakeTwoNumberAndReturnTheResult(a, b);
                someClassThatDoesStuff.TakeInAStringAndWritesItOut(string.Format("The result was {0}..", result));
            }
        }


        public void CalculateDataWay1( Int32 a, Int32 b )
        {
            var stuff = new SomeClassThatDoesStuff();
            PerformLogic(stuff.TakeTwoNumberAndReturnTheResult, stuff.TakeInAStringAndWritesItOut,
                a, b );
        }

        public void CalculateDataWay2(Int32 a, Int32 b)
        {
            var stuff = new AnotherClassThatDoesStuff();
            PerformLogic(stuff.TakeTwoNumberAndReturnTheResult, stuff.TakeInAStringAndWritesItOut,
                a, b);
        }

        private void PerformLogic( Func<Int32, Int32, Int32> calcHandler, Action<string> writeHandler,
            Int32 a, Int32 b)
        {
            var result = calcHandler(a, b);
            writeHandler(string.Format("Write this out{0}", result));
        }

        //private void PerformLogic( MethodTakesIntsAndReturnsHandler calcHandler,
        //    MethodTakesStringWithNoReturnHandler writeHandler, Int32 a, Int32 b)
        //{
        //    var result = calcHandler(a, b);
        //    writeHandler(string.Format("Write this out{0}", result));
        //}

    }

}
